This Folder contains script and instructions to achieve and ODTN phase 1.0 demo on EDGE-CORE CASSINI device with 
IPInfusion OCNos Software.

## Bill of Material (BOM)

### Devices:
* 2x EDGECORE CASSINI
* 2x ACO-PIU from EdgeCore
* 1x Server  (e.g) OCP Inspired™ QuantaGrid D51B-1U server. Each server is configured with 2x Intel E5-2630 v4 10C 2.2GHz 85W, 64GB of RAM 2133MHz DDR4, 2x 500GB HDD, and a 40 Gig adapter.
* 1x 40G NIC (Intel Ethernet Converged Network Adapters XL710 10/40 GbE PCIe 3.0)
* 1x Router
* 1x 8 port switch

## Optical Cards:
* 2x Oclaro CFP2-ACO

## Cables
* 2x 40G QSP828+ Robofiber QSFP-40G-03C QSFP+ 40G direct attach passive copper cable, 3m length - S/N: QSFP-40G-03C
* 1x Optical Fiber for Oclaro Cards
* 6x 1g Management copper cables


## Software needed
Required Ubuntu 16.04 or 18.04 and bazel 0.19.2 or higher.
```
cd ~
```
Clone this repo
```
git clone https://gerrit.onosproject.org/odtn-demo
```
Clone ONOS
```
git clone https://github.com/opennetworkinglab/onos
```

## Demo setup on server
```
cd ~/odtn-demo/cassini-demo
```
### Setup network namespace for 2 hosts
```
sudo ./name-space.sh h1 ens6f0 2 10.0.0.1
sudo ./name-space.sh h2 ens6f1 2 10.0.0.2
 ```
### Setup and start the UI
```
cd ~/odtn-demo/odtn-phase1-demo
```
```
yarn install
```
**Note: the install command has to be run only once, the first time**
then
```
yarn start
```
### Start and configure ONOS
**Note: Please make sure to have sourced the bashrc for the terminal as exaplained in the [ONOS wiki](https://wiki.onosproject.org/display/ONOS/Adding+ONOS+utility+scripts+and+functions+to+your+environment).**  
```
cd ~/odtn-demo/cassini-demo
```
To start ONOS
```
./demo-reset.sh
```
**Note: Please change the IPs, passwords and deviceId according to your devices and hosts in the different .json files.  e.g. `openconfig-device-cassini-test1.json`**

To configure ONOS
```
./config-onos.sh
```
## Run demo
From a terminal in any given machine that is able to reach the management server
### ONOS CLI
```
ssh -p 8101 onos@<ip_of_server>
```
passowd will be most likely `karaf`
### ONOS UI
[http://<ip_of_server>:8181/onos/ui/login.htm](http://<ip_of_server>:8181/onos/ui/login.htm)
### ODTN DEMO APP UI
[http://<ip_of_server>:3000](http://<ip_of_server>:3000)
### Traffic
To see the ping properly flowing between the two hosts ssh into the server in two terminal windows and execute
### H1 --> H2
```
sudo ip netns exec h1 ping -I ens6f0.2 <ip_h2>
```
### H2 --> H1
```
sudo ip netns exec h2 ping -I ens6f1.2 <ip_h1>
```

## Learn More

You can learn more in the [ONOS Wiki](https://wiki.onosproject.org/display/ONOS/Wiki+Home).

To learn React, check out the [ODTN Wiki](https://wiki.onosproject.org/display/ODTN/ODTN).
